]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Set version to 2.5beta2
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.5beta2"
28 CORE="28"
29 GIT_BRANCH=master:master # Version number
30 SLOGAN="www.ipfire.org" # Software slogan
31 CONFIG_ROOT=/var/ipfire # Configuration rootdir
32 NICE=10 # Nice level
33 MAX_RETRIES=1 # prefetch/check loop
34 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
35 MACHINE=`uname -m`
36 GIT_TAG=$(git tag | tail -1)
37 TOOLCHAINVER=1
38 IPFVER="full" # Which versions should be compiled? (full|devel)
39
40 # Debian specific settings
41 if [ ! -e /etc/debian_version ]; then
42 FULLPATH=`which $0`
43 else
44 if [ -x /usr/bin/realpath ]; then
45 FULLPATH=`/usr/bin/realpath $0`
46 else
47 echo "ERROR: Need to do apt-get install realpath"
48 exit 1
49 fi
50 fi
51
52 PWD=`pwd`
53 BASENAME=`basename $0`
54 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
55 LOGFILE=$BASEDIR/log/_build.preparation.log
56 export BASEDIR LOGFILE
57 DIR_CHK=$BASEDIR/cache/check
58 mkdir $BASEDIR/log/ 2>/dev/null
59
60 # Include funtions
61 . tools/make-functions
62
63 if [ -f .config ]; then
64 . .config
65 else
66 echo -e "${BOLD}No configuration found!${NORMAL}"
67 echo -ne "Do you want to create one (y/N)?"
68 read CREATE_CONFIG
69 echo ""
70 if [ "$CREATE_CONFIG" == "y" ]; then
71 make_config
72 fi
73 fi
74
75 if [ -z $EDITOR ]; then
76 for i in nano emacs vi; do
77 EDITOR=$(which $i 2>/dev/null)
78 if ! [ -z $EDITOR ]; then
79 export EDITOR=$EDITOR
80 break
81 fi
82 done
83 [ -z $EDITOR ] && exiterror "You should have installed an editor."
84 fi
85
86 prepareenv() {
87 ############################################################################
88 # #
89 # Are we running the right shell? #
90 # #
91 ############################################################################
92 if [ ! "$BASH" ]; then
93 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
94 fi
95
96 if [ -z "${BASH_VERSION}" ]; then
97 exiterror "Not running BASH shell."
98 fi
99
100
101 ############################################################################
102 # #
103 # Trap on emergency exit #
104 # #
105 ############################################################################
106 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
107
108
109 ############################################################################
110 # #
111 # Resetting our nice level #
112 # #
113 ############################################################################
114 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
115 renice $NICE $$ > /dev/null
116 if [ `nice` != "$NICE" ]; then
117 beautify message FAIL
118 exiterror "Failed to set correct nice level"
119 else
120 beautify message DONE
121 fi
122
123
124 ############################################################################
125 # #
126 # Checking if running as root user #
127 # #
128 ############################################################################
129 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
130 if [ `id -u` != 0 ]; then
131 beautify message FAIL
132 exiterror "Not building as root"
133 else
134 beautify message DONE
135 fi
136
137
138 ############################################################################
139 # #
140 # Checking for necessary temporary space #
141 # #
142 ############################################################################
143 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
144 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
145 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
146 if (( 2048000 > $BASE_ASPACE )); then
147 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
148 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
149 beautify message FAIL
150 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
151 fi
152 else
153 beautify message DONE
154 fi
155
156 ############################################################################
157 # #
158 # Building Linux From Scratch system #
159 # #
160 ############################################################################
161 # Set umask
162 umask 022
163
164 # Set LFS Directory
165 LFS=$BASEDIR/build
166
167 # Check /tools symlink
168 if [ -h /tools ]; then
169 rm -f /tools
170 fi
171 if [ ! -a /tools ]; then
172 ln -s $BASEDIR/build/tools /
173 fi
174 if [ ! -h /tools ]; then
175 exiterror "Could not create /tools symbolic link."
176 fi
177
178 # Setup environment
179 set +h
180 LC_ALL=POSIX
181 if [ -z $MAKETUNING ]; then
182 MAKETUNING="-j6"
183 fi
184 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
185 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
186
187 # Make some extra directories
188 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
189 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
190 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
191 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
192
193 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
194 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
195
196 # Make all sources and proc available under lfs build
197 mount --bind /dev $BASEDIR/build/dev
198 mount --bind /dev/pts $BASEDIR/build/dev/pts
199 mount --bind /dev/shm $BASEDIR/build/dev/shm
200 mount --bind /proc $BASEDIR/build/proc
201 mount --bind /sys $BASEDIR/build/sys
202 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
203 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
204 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
205 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
206 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
207 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
208 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
209 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
210 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
211
212 # This is a temporary hack!!!
213 if [ ! -f /tools/bin/hostname ]; then
214 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
215 fi
216
217 # Run LFS static binary creation scripts one by one
218 export CCACHE_DIR=$BASEDIR/ccache
219 export CCACHE_HASHDIR=1
220
221 # Remove pre-install list of installed files in case user erase some files before rebuild
222 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
223 }
224
225 buildtoolchain() {
226 LOGFILE="$BASEDIR/log/_build.toolchain.log"
227 export LOGFILE
228 ORG_PATH=$PATH
229 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
230 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
231 lfsmake1 ccache
232 lfsmake1 binutils PASS=1
233 lfsmake1 gcc PASS=1
234 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
235 lfsmake1 linux-libc-header
236 lfsmake1 glibc
237 lfsmake1 cleanup-toolchain PASS=1
238 lfsmake1 tcl
239 lfsmake1 expect
240 lfsmake1 dejagnu
241 lfsmake1 gcc PASS=2
242 lfsmake1 binutils PASS=2
243 lfsmake1 ncurses
244 lfsmake1 bash
245 lfsmake1 bzip2
246 lfsmake1 coreutils
247 lfsmake1 diffutils
248 lfsmake1 findutils
249 lfsmake1 gawk
250 lfsmake1 gettext
251 lfsmake1 grep
252 lfsmake1 gzip
253 lfsmake1 m4
254 lfsmake1 make
255 lfsmake1 patch
256 lfsmake1 perl
257 lfsmake1 sed
258 lfsmake1 tar
259 lfsmake1 texinfo
260 lfsmake1 util-linux
261 lfsmake1 cleanup-toolchain PASS=2
262 export PATH=$ORG_PATH
263 }
264
265 buildbase() {
266 LOGFILE="$BASEDIR/log/_build.base.log"
267 export LOGFILE
268 lfsmake2 stage2
269 lfsmake2 linux-libc-header
270 lfsmake2 man-pages
271 lfsmake2 glibc
272 lfsmake2 cleanup-toolchain PASS=3
273 lfsmake2 binutils
274 lfsmake2 gcc
275 lfsmake2 berkeley
276 lfsmake2 coreutils
277 lfsmake2 iana-etc
278 lfsmake2 m4
279 lfsmake2 bison
280 lfsmake2 ncurses
281 lfsmake2 procps
282 lfsmake2 sed
283 lfsmake2 libtool
284 lfsmake2 perl
285 lfsmake2 readline
286 lfsmake2 zlib
287 lfsmake2 autoconf
288 lfsmake2 automake
289 lfsmake2 bash
290 lfsmake2 bzip2
291 lfsmake2 diffutils
292 lfsmake2 e2fsprogs
293 lfsmake2 ed
294 lfsmake2 file
295 lfsmake2 findutils
296 lfsmake2 flex
297 lfsmake2 gawk
298 lfsmake2 gettext
299 lfsmake2 grep
300 lfsmake2 groff
301 lfsmake2 gzip
302 lfsmake2 inetutils
303 lfsmake2 iproute2
304 lfsmake2 kbd
305 lfsmake2 less
306 lfsmake2 libaal
307 lfsmake2 make
308 lfsmake2 man
309 lfsmake2 mktemp
310 lfsmake2 module-init-tools
311 lfsmake2 mtd
312 lfsmake2 net-tools
313 lfsmake2 patch
314 lfsmake2 psmisc
315 lfsmake2 reiser4progs
316 lfsmake2 shadow
317 lfsmake2 sysklogd
318 lfsmake2 sysvinit
319 lfsmake2 tar
320 lfsmake2 texinfo
321 lfsmake2 udev
322 lfsmake2 util-linux
323 lfsmake2 vim
324 lfsmake2 grub
325 }
326
327 buildipfire() {
328 LOGFILE="$BASEDIR/log/_build.ipfire.log"
329 export LOGFILE
330 ipfiremake configroot
331 ipfiremake backup
332 ipfiremake dhcp
333 ipfiremake dhcpcd
334 ipfiremake libusb
335 ipfiremake libpcap
336 ipfiremake ppp
337 ipfiremake rp-pppoe
338 ipfiremake pptp
339 ipfiremake unzip
340 ipfiremake which
341 ipfiremake linux XEN=1
342 ipfiremake atl2 XEN=1
343 ipfiremake kqemu XEN=1
344 ipfiremake v4l-dvb XEN=1
345 ipfiremake madwifi XEN=1
346 # ipfiremake alsa XEN=1 KMOD=1
347 ipfiremake openswan XEN=1 KMOD=1
348 ipfiremake mISDN XEN=1
349 ipfiremake compat-wireless XEN=1
350 ipfiremake linux
351 ipfiremake atl2
352 ipfiremake kqemu
353 ipfiremake v4l-dvb
354 ipfiremake madwifi
355 ipfiremake alsa KMOD=1
356 ipfiremake openswan KMOD=1
357 ipfiremake mISDN
358 ipfiremake compat-wireless
359 ipfiremake pkg-config
360 ipfiremake linux-atm
361 ipfiremake cpio
362 ipfiremake klibc
363 ipfiremake mkinitcpio
364 ipfiremake udev KLIBC=1
365 ipfiremake expat
366 ipfiremake gdbm
367 ipfiremake gmp
368 ipfiremake pam
369 ipfiremake openssl
370 ipfiremake curl
371 ipfiremake python
372 ipfiremake libnet
373 ipfiremake libnl
374 ipfiremake libidn
375 ipfiremake libjpeg
376 ipfiremake libpng
377 ipfiremake libtiff
378 ipfiremake libart
379 ipfiremake freetype
380 ipfiremake gd
381 ipfiremake popt
382 ipfiremake pcre
383 ipfiremake slang
384 ipfiremake newt
385 ipfiremake libcap
386 ipfiremake pciutils
387 ipfiremake usbutils
388 ipfiremake libxml2
389 ipfiremake libxslt
390 ipfiremake BerkeleyDB
391 ipfiremake mysql
392 ipfiremake cyrus-sasl
393 ipfiremake openldap
394 ipfiremake apache2
395 ipfiremake php
396 ipfiremake apache2 PASS=C
397 ipfiremake arping
398 ipfiremake beep
399 ipfiremake bind
400 ipfiremake cdrtools
401 ipfiremake dnsmasq
402 ipfiremake dosfstools
403 ipfiremake squashfstools
404 ipfiremake reiserfsprogs
405 ipfiremake xfsprogs
406 ipfiremake sysfsutils
407 ipfiremake fuse
408 ipfiremake ntfs-3g
409 ipfiremake ethtool
410 ipfiremake ez-ipupdate
411 ipfiremake fcron
412 ipfiremake perl-GD
413 ipfiremake GD-Graph
414 ipfiremake GD-TextUtil
415 ipfiremake gnupg
416 ipfiremake hdparm
417 ipfiremake sdparm
418 ipfiremake mtools
419 ipfiremake initscripts
420 ipfiremake whatmask
421 ipfiremake iptables
422 ipfiremake libupnp
423 ipfiremake ipaddr
424 ipfiremake iptstate
425 ipfiremake iputils
426 ipfiremake l7-protocols
427 ipfiremake mISDNuser
428 ipfiremake capi4k-utils
429 ipfiremake hwdata
430 ipfiremake kudzu
431 ipfiremake logrotate
432 ipfiremake logwatch
433 ipfiremake misc-progs
434 ipfiremake nano
435 ipfiremake nasm
436 ipfiremake URI
437 ipfiremake HTML-Tagset
438 ipfiremake HTML-Parser
439 ipfiremake Compress-Zlib
440 ipfiremake Digest
441 ipfiremake Digest-SHA1
442 ipfiremake Digest-HMAC
443 ipfiremake libwww-perl
444 ipfiremake Net-DNS
445 ipfiremake Net-IPv4Addr
446 ipfiremake Net_SSLeay
447 ipfiremake IO-Stringy
448 ipfiremake Unix-Syslog
449 ipfiremake Mail-Tools
450 ipfiremake MIME-Tools
451 ipfiremake Net-Server
452 ipfiremake Convert-TNEF
453 ipfiremake Convert-UUlib
454 ipfiremake Archive-Tar
455 ipfiremake Archive-Zip
456 ipfiremake Text-Tabs+Wrap
457 ipfiremake Locale-Country
458 ipfiremake XML-Parser
459 ipfiremake python-setuptools
460 ipfiremake python-clientform
461 ipfiremake python-mechanize
462 ipfiremake python-feedparser
463 ipfiremake python-rssdler
464 ipfiremake glib
465 ipfiremake GeoIP
466 ipfiremake fwhits
467 ipfiremake noip_updater
468 ipfiremake ntp
469 ipfiremake openssh
470 ipfiremake rrdtool
471 ipfiremake setserial
472 ipfiremake setup
473 ipfiremake snort
474 ipfiremake oinkmaster
475 ipfiremake squid
476 ipfiremake squidguard
477 ipfiremake calamaris
478 ipfiremake tcpdump
479 ipfiremake traceroute
480 ipfiremake vlan
481 ipfiremake wireless
482 ipfiremake libsafe
483 ipfiremake pakfire
484 ipfiremake java
485 ipfiremake spandsp
486 ipfiremake lzo
487 ipfiremake openvpn
488 ipfiremake pammysql
489 ipfiremake cups
490 ipfiremake ghostscript
491 ipfiremake foomatic
492 ipfiremake hplip
493 ipfiremake samba
494 ipfiremake sudo
495 ipfiremake mc
496 ipfiremake wget
497 ipfiremake bridge-utils
498 ipfiremake screen
499 ipfiremake hddtemp
500 ipfiremake smartmontools
501 ipfiremake htop
502 ipfiremake postfix
503 ipfiremake fetchmail
504 ipfiremake cyrus-imapd
505 ipfiremake openmailadmin
506 ipfiremake clamav
507 ipfiremake spamassassin
508 ipfiremake amavisd
509 ipfiremake alsa
510 ipfiremake mpfire
511 ipfiremake guardian
512 ipfiremake libid3tag
513 ipfiremake libmad
514 ipfiremake libogg
515 ipfiremake libvorbis
516 ipfiremake libdvbpsi
517 ipfiremake lame
518 ipfiremake sox
519 ipfiremake libshout
520 ipfiremake xvid
521 ipfiremake libmpeg2
522 ipfiremake cmake
523 ipfiremake libpri
524 ipfiremake asterisk
525 ipfiremake gnump3d
526 ipfiremake libsigc++
527 ipfiremake applejuice
528 ipfiremake ocaml
529 ipfiremake mldonkey
530 ipfiremake libtorrent
531 ipfiremake rtorrent
532 ipfiremake ipfireseeder
533 ipfiremake rsync
534 ipfiremake tcpwrapper
535 ipfiremake portmap
536 ipfiremake nfs
537 ipfiremake nmap
538 ipfiremake ncftp
539 ipfiremake etherwake
540 ipfiremake bwm-ng
541 ipfiremake tripwire
542 ipfiremake sysstat
543 ipfiremake vsftpd
544 ipfiremake openswan
545 ipfiremake lsof
546 ipfiremake centerim
547 ipfiremake br2684ctl
548 ipfiremake pcmciautils
549 ipfiremake lm_sensors
550 ipfiremake collectd
551 ipfiremake lcd4linux
552 ipfiremake tcptrack
553 ipfiremake teamspeak
554 ipfiremake elinks
555 ipfiremake igmpproxy
556 ipfiremake fbset
557 ipfiremake sdl
558 ipfiremake qemu
559 ipfiremake sane
560 ipfiremake netpbm
561 ipfiremake phpSANE
562 ipfiremake tunctl
563 ipfiremake nagios
564 ipfiremake ebtables
565 ipfiremake fontconfig
566 ipfiremake freefont
567 ipfiremake directfb
568 ipfiremake dfb++
569 ipfiremake ffmpeg
570 ipfiremake videolan
571 ipfiremake vdr
572 ipfiremake w_scan
573 ipfiremake icecast
574 ipfiremake icegenerator
575 ipfiremake mpd
576 ipfiremake mpc
577 ipfiremake git
578 ipfiremake squidclamav
579 ipfiremake bc
580 ipfiremake esniper
581 ipfiremake vnstat
582 ipfiremake vnstati
583 ipfiremake iw
584 ipfiremake wpa_supplicant
585 ipfiremake hostapd
586 ipfiremake urlgrabber
587 ipfiremake syslinux
588 ipfiremake tftpd
589 ipfiremake cpufrequtils
590 ipfiremake dbus
591 ipfiremake bluetooth
592 ipfiremake gutenprint
593 ipfiremake apcupsd
594 ipfiremake iperf
595 ipfiremake netcat
596 ipfiremake 7zip
597 ipfiremake lynis
598 ipfiremake cryptsetup
599 ipfiremake splix
600 ipfiremake streamripper
601 ipfiremake sshfs
602 ipfiremake sqlite
603 ipfiremake taglib
604 # ipfiremake mediatomb
605 ipfiremake sslh
606 ipfiremake perl-gettext
607 ipfiremake vdradmin
608 ipfiremake x11libs
609 ipfiremake xen
610 ipfiremake miau
611 ipfiremake net-snmp
612 ipfiremake perl-DBI
613 ipfiremake perl-DBD-mysql
614 ipfiremake lcr
615 echo Build on $HOSTNAME > $BASEDIR/build/var/ipfire/firebuild
616 cat /proc/version >> $BASEDIR/build/var/ipfire/firebuild
617 echo >> $BASEDIR/build/var/ipfire/firebuild
618 git log -1 >> $BASEDIR/build/var/ipfire/firebuild
619 echo >> $BASEDIR/build/var/ipfire/firebuild
620 git status >> $BASEDIR/build/var/ipfire/firebuild
621 echo >> $BASEDIR/build/var/ipfire/firebuild
622 cat /proc/cpuinfo >> $BASEDIR/build/var/ipfire/firebuild
623 echo $CORE > $BASEDIR/build/opt/pakfire/db/core/mine
624 }
625
626 buildinstaller() {
627 # Run installer scripts one by one
628 LOGFILE="$BASEDIR/log/_build.installer.log"
629 export LOGFILE
630 ipfiremake as86
631 ipfiremake mbr
632 ipfiremake memtest
633 installmake linux-libc-header
634 installmake binutils
635 ipfiremake uClibc PASS=1
636 ipfiremake gcc INST=1
637 installmake uClibc PASS=2
638 installmake gcc INST=2
639 installmake uClibc PASS=3
640 installmake busybox
641 installmake udev
642 installmake slang
643 installmake newt
644 installmake gettext
645 installmake kbd
646 installmake popt
647 installmake sysvinit
648 installmake misc-progs
649 installmake libaal
650 installmake reiser4progs
651 installmake reiserfsprogs
652 installmake sysfsutils
653 installmake util-linux
654 installmake pciutils
655 installmake zlib
656 installmake mtd
657 installmake wget
658 installmake hwdata
659 installmake kudzu
660 installmake pcmciautils
661 installmake installer
662 installmake initrd
663 }
664
665 buildpackages() {
666 LOGFILE="$BASEDIR/log/_build.packages.log"
667 export LOGFILE
668 echo "... see detailed log in _build.*.log files" >> $LOGFILE
669
670 installmake strip
671
672 # Generating list of packages used
673 echo -n "Generating packages list from logs" | tee -a $LOGFILE
674 rm -f $BASEDIR/doc/packages-list
675 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
676 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
677 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
678 fi
679 done
680 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
681 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
682 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
683 rm -f $BASEDIR/doc/packages-list
684 # packages-list.txt is ready to be displayed for wiki page
685 beautify message DONE
686
687 # Update changelog
688 cd $BASEDIR
689 $0 git log
690
691 # Create images for install
692 ipfiremake cdrom ED=$IPFVER
693
694 # Check if there is a loop device for building in virtual environments
695 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
696 ipfiremake usb-stick ED=$IPFVER
697 fi
698
699 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
700
701 ipfirepackages
702
703 # Cleanup
704 stdumount
705 rm -rf $BASEDIR/build/tmp/*
706
707 # Generating total list of files
708 echo -n "Generating files list from logs" | tee -a $LOGFILE
709 rm -f $BASEDIR/log/FILES
710 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
711 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
712 echo "##" >>$BASEDIR/log/FILES
713 echo "## `basename $i`" >>$BASEDIR/log/FILES
714 echo "##" >>$BASEDIR/log/FILES
715 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
716 fi
717 done
718 beautify message DONE
719
720 cd $PWD
721 }
722
723 ipfirepackages() {
724 ipfiremake core-updates
725 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
726 if [ -e $BASEDIR/lfs/$i ]; then
727 ipfiredist $i
728 else
729 echo -n $i
730 beautify message SKIP
731 fi
732 done
733 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
734 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
735 rm -rf $BASEDIR/build/install/packages/*
736 }
737
738 # See what we're supposed to do
739 case "$1" in
740 build)
741 clear
742 BUILDMACHINE=`uname -m`
743 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
744 #only restore on a clean disk
745 if [ ! -f log/cleanup-toolchain-2-tools ]; then
746 if [ ! -n "$PACKAGE" ]; then
747 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
748 prepareenv
749 buildtoolchain
750 else
751 PACKAGENAME=${PACKAGE%.tar.gz}
752 beautify build_stage "Packaged toolchain compilation"
753 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
754 tar zxf $PACKAGE
755 prepareenv
756 else
757 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
758 fi
759 fi
760 else
761 echo -n "Using installed toolchain" | tee -a $LOGFILE
762 beautify message SKIP
763 prepareenv
764 fi
765
766 beautify build_start
767 beautify build_stage "Building LFS"
768 buildbase
769
770 beautify build_stage "Building IPFire"
771 buildipfire
772
773 beautify build_stage "Building installer"
774 buildinstaller
775
776 beautify build_stage "Building packages"
777 buildpackages
778
779 beautify build_stage "Checking Logfiles for new Files"
780 cd ..
781 tools/checknewlog.pl
782
783 beautify build_end
784 ;;
785 shell)
786 # enter a shell inside LFS chroot
787 # may be used to changed kernel settings
788 prepareenv
789 entershell
790 ;;
791 clean)
792 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
793 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
794 $LOSETUP -d $i 2>/dev/null
795 done
796 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
797 umount $i
798 done
799 stdumount
800 for i in `seq 0 7`; do
801 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
802 umount /dev/loop${i} 2>/dev/null;
803 losetup -d /dev/loop${i} 2>/dev/null;
804 fi;
805 done
806 rm -rf $BASEDIR/build
807 rm -rf $BASEDIR/cdrom
808 rm -rf $BASEDIR/packages
809 rm -rf $BASEDIR/log
810 if [ -h /tools ]; then
811 rm -f /tools
812 fi
813 beautify message DONE
814 ;;
815 downloadsrc)
816 if [ ! -d $BASEDIR/cache ]; then
817 mkdir $BASEDIR/cache
818 fi
819 mkdir -p $BASEDIR/log
820 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
821 FINISHED=0
822 cd $BASEDIR/lfs
823 for c in `seq $MAX_RETRIES`; do
824 if (( FINISHED==1 )); then
825 break
826 fi
827 FINISHED=1
828 cd $BASEDIR/lfs
829 for i in *; do
830 if [ -f "$i" -a "$i" != "Config" ]; then
831 echo -ne "Loading $i"
832 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
833 if [ $? -ne 0 ]; then
834 beautify message FAIL
835 FINISHED=0
836 else
837 if [ $c -eq 1 ]; then
838 beautify message DONE
839 fi
840 fi
841 fi
842 done
843 done
844 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
845 ERROR=0
846 for i in *; do
847 if [ -f "$i" -a "$i" != "Config" ]; then
848 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
849 if [ $? -ne 0 ]; then
850 echo -ne "MD5 difference in lfs/$i"
851 beautify message FAIL
852 ERROR=1
853 fi
854 fi
855 done
856 if [ $ERROR -eq 0 ]; then
857 echo -ne "${BOLD}all files md5sum match${NORMAL}"
858 beautify message DONE
859 else
860 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
861 beautify message FAIL
862 fi
863 cd - >/dev/null 2>&1
864 ;;
865 toolchain)
866 clear
867 prepareenv
868 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
869 buildtoolchain
870 BUILDMACHINE=`uname -m`
871 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
872 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
873 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-$BUILDMACHINE.tar.gz \
874 build/{bin,etc,usr/bin,usr/local} \
875 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
876 log >> $LOGFILE
877 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-$BUILDMACHINE.tar.gz \
878 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-$BUILDMACHINE.md5
879 stdumount
880 ;;
881 gettoolchain)
882 BUILDMACHINE=`uname -m`
883 # arbitrary name to be updated in case of new toolchain package upload
884 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-$BUILDMACHINE
885 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
886 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
887 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
888 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
889 cd $BASEDIR/cache/toolchains
890 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
891 if [ $? -ne 0 ]; then
892 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
893 else
894 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
895 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
896 else
897 exiterror "$PACKAGE.md5 did not match, check downloaded package"
898 fi
899 fi
900 else
901 echo "Toolchain is already downloaded. Exiting..."
902 fi
903 ;;
904 othersrc)
905 prepareenv
906 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
907 chroot $LFS /tools/bin/env -i HOME=/root \
908 TERM=$TERM PS1='\u:\w\$ ' \
909 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
910 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
911 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
912 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
913 if [ $? -eq "0" ]; then
914 beautify message DONE
915 else
916 beautify message FAIL
917 fi
918 stdumount
919 ;;
920 git)
921 case "$2" in
922 update|up)
923 ## REMOVES ALL UNCOMMITTED CHANGES!
924 [ "$3" == "--force" ] && git checkout -f
925 git pull
926 ;;
927 commit|ci)
928 shift 2
929 git commit $*
930
931 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
932
933 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
934 read
935 [ -z $REPLY ] && exit 0
936 for i in y Y j J; do
937 if [ "$i" == "$REPLY" ]; then
938 $0 git push
939 exit $?
940 fi
941 done
942 exiterror "\"$REPLY\" is not a valid answer."
943 ;;
944 dist)
945 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
946 ;;
947 diff|di)
948 echo -ne "Make a local diff to last revision"
949 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
950 evaluate 1
951 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
952 git diff --stat
953 ;;
954 push)
955 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
956 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
957
958 git push ${GIT_URL} ${GIT_BRANCH} $3
959 ;;
960 log)
961 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
962 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
963
964 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
965 ;;
966 esac
967 ;;
968 uploadsrc)
969 PWD=`pwd`
970 if [ -z $IPFIRE_USER ]; then
971 echo -n "You have to setup IPFIRE_USER first. See .config for details."
972 beautify message FAIL
973 exit 1
974 fi
975 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
976 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
977
978 cd $BASEDIR/cache/
979 for file in $(ls -1); do
980 grep -q "$file" <<<$REMOTE_FILES && continue
981 NEW_FILES="$NEW_FILES $file"
982 done
983 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
984 cd $BASEDIR
985 cd $PWD
986 exit 0
987 ;;
988 upload)
989 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
990 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
991 if [ -z $FTP_ISO_PORT ]; then
992 FTP_ISO_PORT=21
993 fi
994 cat <<EOF > .ftp-commands
995 mkdir -p $FTP_ISO_PATH$SVN_REVISION
996 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
997 quit
998 EOF
999 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
1000 rm -f .ftp-commands
1001
1002 case "$2" in
1003 iso)
1004 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
1005
1006 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
1007 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
1008 if [ -e "$i" ]; then
1009 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
1010 if [ "$?" -eq "0" ]; then
1011 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1012 else
1013 echo "There was an error while uploading the file $i to the ftp server."
1014 exit 1
1015 fi
1016 fi
1017 done
1018 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
1019 if [ "$3" = "--with-sources-cd" ]; then
1020 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1021 fi
1022 ;;
1023 paks)
1024 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1025 if [ "$?" -eq "0" ]; then
1026 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1027 else
1028 echo -e "There was an error while uploading the packages to the ftp server."
1029 exit 1
1030 fi
1031 ;;
1032 esac
1033 ;;
1034 batch)
1035 if [ "$2" = "--background" ]; then
1036 batch_script
1037 exit $?
1038 fi
1039 if [ `screen -ls | grep -q ipfire` ]; then
1040 echo "Build is already running, sorry!"
1041 exit 1
1042 else
1043 if [ "$2" = "--rebuild" ]; then
1044 export IPFIRE_REBUILD=1
1045 echo "REBUILD!"
1046 else
1047 export IPFIRE_REBUILD=0
1048 fi
1049 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1050 screen -dmS ipfire $0 batch --background
1051 evaluate 1
1052 exit 0
1053 fi
1054 ;;
1055 watch)
1056 watch_screen
1057 ;;
1058 pxe)
1059 case "$2" in
1060 start)
1061 start_tftpd
1062 ;;
1063 stop)
1064 stop_tftpd
1065 ;;
1066 reload|restart)
1067 reload_tftpd
1068 ;;
1069 esac
1070 exit 0
1071 ;;
1072 lang)
1073 update_langs
1074 ;;
1075 "")
1076 clear
1077 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1078 do
1079 case $name in
1080 "IPFIRE: Downloadsrc")
1081 $0 downloadsrc
1082 ;;
1083 "IPFIRE: Build (silent)")
1084 $0 build-silent
1085 ;;
1086 "IPFIRE: Watch Build")
1087 $0 watch
1088 ;;
1089 "IPFIRE: Batch")
1090 $0 batch
1091 ;;
1092 "IPFIRE: Clean")
1093 $0 clean
1094 ;;
1095 "Help")
1096 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1097 cat doc/make.sh-usage
1098 ;;
1099 "LOG: Tail")
1100 tail -f log/_*
1101 ;;
1102 "Exit")
1103 break
1104 ;;
1105 esac
1106 done
1107 ;;
1108 config)
1109 make_config
1110 ;;
1111 *)
1112 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1113 cat doc/make.sh-usage
1114 ;;
1115 esac